#include "option.h"
#include <string.h>
#include "inout.h"
#include "commun.h"
#include "invariant.h"

int ctrl( char * str, char c  )
{ 
	while ( *str ) {
		if ( *str == c ) return 1;
		str++;
	}
	return 0;
}

int test ( graphe * g )
{ int resultat = 1, result;
  if  ( optinvstr ) 
	  if ( ! invtest( g, optinvstr ) )
	  return 0;

  if ( ! optfiltre ) return 1;
  
  char tampon[64];
  strcpy( tampon, optfiltre );
  char * ptr = tampon;
  graphe adjGraphe, cmpGraphe;
  if (  ctrl( optfiltre, ':') ) 
	  adjGraphe = adjoint( g );
  if (  ctrl( optfiltre, '/') ) 
	  cmpGraphe = complement( g );
  char *msg = "graphe";
  while ( *ptr  && ( verbe || resultat )  ) {
	  result = 1;
	  switch( *ptr ) {
		case '^' : case '-' : ptr++; *ptr = toupper(*ptr); ptr--;
			   break;
		case '/' : g = &cmpGraphe;
			   msg =  "complémentaire";
			   break;
		case ':' : g = &adjGraphe;
			   msg = "adjoint";
			   break;
		case 'a' : if ( ! arbre( g ) ) 
				   result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "non arbre");
			break;
		case 'A' : if ( arbre( g )  ) result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "arbre");
			break;
		case 'c' : if ( ! connexe( g ) ) 
				   result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "non connexe");
			break;
		case 'C' : if (  connexe( g )  ) result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "connexe");
			break;
		case 'b' : if ( ! bicolore( g ) ) 
				   result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "non bicolore");
			break;
		case 'B' : if (  bicolore( g )  ) result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "bicolore");
			break;
		case 'i' : if ( ! isolani( g ) ) 
				   result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "pas de point isolé");
			break;
		case 'I' : if (  isolani( g )  ) result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "présence de point isolé");
			break;
		case 'e' : if ( ! eulerien( g ) ) result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "non eulerien");
			break;
		case 'E' : if ( eulerien( g ) ) result   = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "eulerien");
			break;
		case 'h' : if ( ! hamiltonien( g ) ) result = 0;
			   if ( ! result && verbe ) 
				   printf(" [ %s -> %s ]", msg, "non hamiltonien");
			break;
		case 'H' : if ( hamiltonien( g ) ) result = 0;
			   if ( ! result && verbe ) printf(" [ %s -> %s ]", msg, "hamiltonien");
			break;
		default : 
			printf("descripteur de type %c invalide !\n", *ptr);
			exit(1);
	  }
	  ptr++;
	  if ( result == 0 ) resultat = 0;
  }
 if ( ctrl(optfiltre, ':' ) )
		 freeGraphe( adjGraphe );
 if ( ctrl(optfiltre, '/' ) )
 	freeGraphe( cmpGraphe );
 return resultat;
}


void Dessiner( graphe *g , int num )
{ graphe t;
	g->numero = num;
        dessiner( g );
        if ( optdraw < 2 ) return;
        t = complement( g );
        sprintf( t.ident,"cmp_%s", g->ident );
	t.numero = num;
        dessiner( &t );
        freeGraphe( t );
        t = adjoint( g );
        sprintf( t.ident,"adj_%s", g->ident );
	t.numero = num;
        dessiner( &t );
        freeGraphe( t );
}

