#include "graphe.h"
#include "option.h"
#include <string.h>

char * galerie = "galerie";

void Galerie( char * r )
{ char cmd[128];
  sprintf(cmd, "mkdir %s", r );
  system( cmd );
  galerie = strdup( r ) ; 
}

void print(graphe * G)
{
    int i, j;
    printf("\n\ngraphe : %s\n", G->ident);
    for (i = 0; i < G->nbs; i++) {
	printf("%d : ", i);
	for (j = 0; j < G->nbs; j++)
	    if (G->mat[i][j])
		printf("%3d", j);

	putchar('\n');
    }
}


void statistique(graphe * g)
{
    int s;
    if (g->inv) {
	printf("\ninvariant");
	for (s = 0; s < g->nbs; s++)
	    printf(":%d", g->inv[s]);
        putchar('\n');
    }
}

graphe inputGraphe(FILE * src)
{
    int n = 0, x, y, z, t;
    graphe G;
    char ligne[1024];
    while (fgets(ligne, 1024, src)) {
	switch (ligne[0]) {
	case 'n':
	    if (sscanf(ligne, "nbs=%d", &n) == 1)
		G = initGraphe(n);
	    break;
	case '#':
	    break;
	default:
	    if (n > 0) {
		t = sscanf(ligne, "%d %d %d ", &x, &y, &z);
		if (t == 3)
		    G.mat[x][y] = z;
		if (t == 2)
		    G.mat[x][y] = G.mat[y][x] = 1;
	    }
	}
    }
    return G;
}

void dotGraphe(graphe * G, const char *nom)
{
    char fn[64];
    FILE *dst;
    int i, j;
    sprintf(fn, "%s/%s.dot", galerie, nom);
    dst = fopen(fn, "w");
    if (!dst) {
	perror("dotwGraphe");
	puts(fn );
	exit(1);
    }
    fprintf(dst, "graph %s {\n", nom);
    fputs("\t node [ shape=circle ];\n", dst);
    for (i = 0; i < G->nbs; i++)
		fprintf(dst, "%d;\n", i);
    for (i = 0; i < G->nbs; i++)
	for (j = i + 1; j < G->nbs; j++)
	    if (G->mat[i][j])
		fprintf(dst, "%d -- %d ;\n", i, j);
    fputc('}', dst);
    fclose(dst);
}

void dessiner( graphe * g )
{
    char cmd[1024];
    char fn[128];

    sprintf( fn ,"%s_%d_%d", g->ident, g->nbs, g->numero );
    dotGraphe(g,  fn  );
    fprintf(stderr, "nouvelle image : %s/%s.png\n", galerie, fn );
    sprintf(cmd, "%s -Tpng %s/%s.dot -o %s/%s.png", optdot, galerie, fn, galerie, fn);
    system(cmd);
}


