#include "option.h"
#include <string.h>
#include "inout.h"
#include "commun.h"
#include "invariant.h"

int  optdraw = 0 , optprint = 0, optinv = 0, verbe = 0, optordre = 4;

char *optlabel = "graphe";
char *optdot   = "neato";
FILE *source     = NULL;
char *optfiltre  = NULL;
char *optgalerie = "galerie";
char *optinvstr = NULL;

void help(void)
{
puts("\n\t-r {répertoire} : répertoire pour les images, deafaut = galerie, exemple : -r tempo"
"\n\t-s {source}  : exemple,  exemple : -s data/maison.dat"
"\n\t-n {val}     : ordre des graphe , defaut:4,  exemple  : -n 5"
"\n\t-l {label}   : label pour les noms de images, exemple : -l graphe"
"\n\t-p : afficher le graphe en mode texte"
"\n\t-a {algo}: algorithme dot, default = neato, voir : man dot"
"\n\t-d : dessiner le graphe le répertoire des images"
"\n\t-D : dessiner les graphes adjoints et complémentaire"
"\n\t-i : imprimer les invariants"
"\n\t-v : mode verbeux, plus d'informations, exemple :  ./zoo.exe -v -i"
"\n\t-h : aide"
"\n\t-j {invariant} :filtre invariant : exemple -n 4 -j invariant:2:2:3:3 "
"\n\t-F {filtre}    :aide sur le filtre  : exemple -F che"
"\n\t-f {filtre}    :filtre des graphes, adjoints et complémentaire"
"\n\t   [:/^abcehi]*"
"\nEXEMPLES");
helptype( "c:c/c" );
helptype( "^che" );
helptype( "bi/ch:^e" );
}

void option(int argc, char *argv[])
{

    char *option = "a:dDf:F:l:n:r:ij:phs:v";
    int opt;

    while ((opt = getopt(argc, argv, option)) != -1) {
	switch (opt) {
	case 'a' :
		optdot = strdup( optarg );
		break;
	case 'd':
	    optdraw++;
	    break;
	case 'D':
	    optdraw+=2;
	    break;
	case 'l':
	    optlabel = strdup(optarg);
	    break;
	case 'r':
	    Galerie(optarg);
	    optdraw++;
	    break;
	case 's':
	    source = fopen( optarg, "r" );
	    if ( ! source  ) {
		    perror( "source");
		    puts( optarg );
		    exit(1);
	    } 
	    break;
	case 'i':
	    optinv++;
	    break;
	case 'p':
	    optprint++;
	    break;
	case 'v':
	    verbe++;
	    break;
	case 'j':
	    optinvstr = strdup(optarg);
	    break;
	case 'n':
	    optordre = atoi(optarg);
	    break;
	case 'f' :
	    optfiltre = strdup( optarg );
	    break;
	case 'F' :
	    helptype( optarg );
	    exit(1);
	    break;
	default:		/* '?' */
	    fprintf(stderr, "Usage: %s is %s\n", argv[0], option);
	  case 'h':
	    help();
	    exit(EXIT_FAILURE);
	}
    }
}




void helptype( char* motif )
{ 
  int first  = 0;
  if ( ! motif ) return;
  char tampon[64];
  strcpy( tampon, motif );
  char * ptr = tampon;

  printf("Filtre %s ", ptr );
  printf("\n  GRAPHE:");
  while ( *ptr ) {
	  switch( *ptr ) {
		case '^' : case '-' : ptr++; *ptr = toupper(*ptr); ptr--;
			   break;
		case '/' : printf(" COMPLEMENT:");
			   first=0;
			   break;
		case ':' : printf(" ADJOINT:");
			   first=0;
			   break;
		case 'a' : 
			printf(" arbre");
			break;
		case 'A' : 
			printf(" non arbre");
			break;
		case 'b' : 
			if ( first++ ) putchar(',');
			printf(" bicolore");
			break;
		case 'B' : 
			if ( first++ ) putchar(',');
			printf(" non bicolore");
			break;
		case 'i' : 
			if ( first++ ) putchar(',');
			printf(" sans isolani");
			break;
		case 'I' : 
			if ( first++ ) putchar(',');
			printf(" avec isolani");
			break;
			   break;
		case 'c' : 
			if ( first++ ) putchar(',');
			printf(" connexe");
			break;
		case 'C' : 
			if ( first++ ) putchar(',');
			printf(" non connexe");
			break;
		case 'e' : 
			if ( first++ ) putchar(',');
			printf(" eulerien");
			break;
		case 'E' :
			if ( first++ ) putchar(',');
			printf(" non eulerien");
			break;
		case 'h' :
			if ( first++ ) putchar(',');
			printf(" hamiltonien");
			break;
		case 'H' : 
			if ( first++ ) putchar(',');
			printf(" non hamiltonien");
			break;
		case ','    :
			break;
		default : 
			printf("descripteur de type %c invalide !\n", *ptr);
			exit(1);
	  }
	  ptr++;
  }
 putchar('\n');
}


